// --------------------------------------------------------------------------
// COPYRIGHT (c) Freescale 2009
// Freescale Confidential Proprietary
//  All Rights Reserved
// --------------------------------------------------------------------------
//!\file    typedefs.h
//!\brief   This file contains various type defines for datatypes
//
// TYPE: Header File
// DEPARTMENT: MSG
// CREATED BY: Jeff Loeliger  (B04629)
// --------------------------------------------------------------------------
// PURPOSE:  This file contains various type defines for datatypes
// --------------------------------------------------------------------------
// $Log: typedefs.h.rca $
// 
//  Revision: 1.2 Wed Nov 21 23:04:20 2012 PankajKushwahaFSL
//  Matterhorn working code
// 
//  Revision: 1.1 Mon Sep 10 01:46:02 2012 PankajKushwahaFSL
//  Initial version for Matterhorn validation code
// 
//  Revision: 1.2 Thu Mar  1 00:34:42 2012 AijazFatimaFSL
//  *** empty comment string ***
// 
//  Revision: 1.1 Tue Apr 19 04:10:02 2011 AijazFatimaFSL
//  Initial version
// 
//  Revision: 1.3 Wed Jan  5 00:44:54 2011 B22414
//  *** empty comment string ***
// 
//  Revision: 1.2 Wed Dec 29 03:27:53 2010 B22414
//  *** empty comment string ***
// 
//  Revision: 1.1 Thu Mar  5 18:02:56 2009 AnkurSharmaFSL
//  Initial Check In
// --------------------------------------------------------------------------

#ifndef _TYPEDEFS_H_
#define _TYPEDEFS_H_

#ifdef __MWERKS__    //Metrowerk CodeWarrior
    #include <stdint.h>

    // Standard typedefs used by header files, based on ISO C standard
    typedef volatile int8_t vint8_t;
    typedef volatile uint8_t vuint8_t;

    typedef volatile int16_t vint16_t;
    typedef volatile uint16_t vuint16_t;

    typedef volatile int32_t vint32_t;
    typedef volatile uint32_t vuint32_t;

#else
#ifdef __ghs__    //GreenHills
    #include <stdint.h>

    // Standard typedefs used by header files, based on ISO C standard
    typedef volatile int8_t vint8_t;
    typedef volatile uint8_t vuint8_t;

    typedef volatile int16_t vint16_t;
    typedef volatile uint16_t vuint16_t;

    typedef volatile int32_t vint32_t;
    typedef volatile uint32_t vuint32_t;

    typedef (*FUNC_PTR)(void *); 
#else

    // This is needed for compilers that don't have a stdint.h file

    typedef signed char int8_t;
    typedef unsigned char uint8_t;
    typedef volatile signed char vint8_t;
    typedef volatile unsigned char vuint8_t;

    typedef signed short int16_t;
    typedef unsigned short uint16_t;
    typedef volatile signed short vint16_t;
    typedef volatile unsigned short vuint16_t;

    typedef signed int int32_t;
    typedef unsigned int uint32_t;
    typedef volatile signed int vint32_t;
    typedef volatile unsigned int vuint32_t;


#endif
#endif
#endif

#define REG32(x)					*(vuint32_t*)(x)

#define PIT_RTI_PITMCR                 (REG32(PIT_RTI_REGS_BASE+0x00000000) ) 

#define PIT_RTI_LDVAL0                 (REG32(PIT_RTI_REGS_BASE+0x00000100) ) 
#define PIT_RTI_TFLG0                  (REG32(PIT_RTI_REGS_BASE+0x0000010C) ) 
#define PIT_RTI_TCTRL0                 (REG32(PIT_RTI_REGS_BASE+0x00000108) ) 
#define PIT_RTI_REGS_BASE                 (0xFFF84000)


#define BAF_PIT_MCR_MDIS                  (0x00000002) 
#define BAF_PIT_MCR_FRZ                   (0x00000001) 
#define BAF_PIT_TFL                       (0x00000001) 
#define BAF_PIT_TCTL_TEN                  (0x00000001) 
//#define PIT_RTI_REGS_BASE                 (PIT_RTI0_REGS_BASE) 
#define BAF_IF_PIT_EXPIRED                (PIT_RTI_TFLG0 & 0x00000001) 
#define BAF_3mS_PIT_CNT_AT_16_MHz         (50000)



/*********************************************************************
 *
 * Copyright:
 *	Freescale Semiconductor, INC. All Rights Reserved.
 *  You are hereby granted a copyright license to use, modify, and
 *  distribute the SOFTWARE so long as this entire notice is
 *  retained without alteration in any modified and/or redistributed
 *  versions, and that such modified versions are clearly identified
 *  as such. No licenses are granted by implication, estoppel or
 *  otherwise under any patents or trademarks of Freescale
 *  Semiconductor, Inc. This software is provided on an "AS IS"
 *  basis and without warranty.
 *
 *  To the maximum extent permitted by applicable law, Freescale
 *  Semiconductor DISCLAIMS ALL WARRANTIES WHETHER EXPRESS OR IMPLIED,
 *  INCLUDING IMPLIED WARRANTIES OF MERCHANTABILITY OR FITNESS FOR A
 *  PARTICULAR PURPOSE AND ANY WARRANTY AGAINST INFRINGEMENT WITH
 *  REGARD TO THE SOFTWARE (INCLUDING ANY MODIFIED VERSIONS THEREOF)
 *  AND ANY ACCOMPANYING WRITTEN MATERIALS.
 *
 *  To the maximum extent permitted by applicable law, IN NO EVENT
 *  SHALL Freescale Semiconductor BE LIABLE FOR ANY DAMAGES WHATSOEVER
 *  (INCLUDING WITHOUT LIMITATION, DAMAGES FOR LOSS OF BUSINESS PROFITS,
 *  BUSINESS INTERRUPTION, LOSS OF BUSINESS INFORMATION, OR OTHER
 *  PECUNIARY LOSS) ARISING OF THE USE OR INABILITY TO USE THE SOFTWARE.
 *
 *  Freescale Semiconductor assumes no responsibility for the
 *  maintenance and support of this software
 *
 ********************************************************************/


